Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3322)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3337)
@@ -7143,4 +7958,39 @@
 !>    array for csf
 !------------------------------------------------------------------------------!
+!-- quicksort.f -*-f90-*-
+!-- Author: t-nissie, adaptation J.Resler
+!-- License: GPLv3
+!-- Gist: https://gist.github.com/t-nissie/479f0f16966925fa29ea
+    RECURSIVE SUBROUTINE quicksort_itarget(itarget, vffrac, ztransp, first, last)
+        IMPLICIT NONE
+        INTEGER(iwp), DIMENSION(:), INTENT(INOUT)   :: itarget
+        REAL(wp), DIMENSION(:), INTENT(INOUT)       :: vffrac, ztransp
+        INTEGER(iwp), INTENT(IN)                    :: first, last
+        INTEGER(iwp)                                :: x, t
+        INTEGER(iwp)                                :: i, j
+        REAL(wp)                                    :: tr
+
+        IF ( first>=last ) RETURN
+        x = itarget((first+last)/2)
+        i = first
+        j = last
+        DO
+            DO WHILE ( itarget(i) < x )
+               i=i+1
+            ENDDO
+            DO WHILE ( x < itarget(j) )
+                j=j-1
+            ENDDO
+            IF ( i >= j ) EXIT
+            t = itarget(i);  itarget(i) = itarget(j);  itarget(j) = t
+            tr = vffrac(i);  vffrac(i) = vffrac(j);  vffrac(j) = tr
+            tr = ztransp(i);  ztransp(i) = ztransp(j);  ztransp(j) = tr
+            i=i+1
+            j=j-1
+        ENDDO
+        IF ( first < i-1 ) CALL quicksort_itarget(itarget, vffrac, ztransp, first, i-1)
+        IF ( j+1 < last )  CALL quicksort_itarget(itarget, vffrac, ztransp, j+1, last)
+    END SUBROUTINE quicksort_itarget
+
     PURE FUNCTION svf_lt(svf1,svf2) result (res)
       TYPE (t_svf), INTENT(in) :: svf1,svf2
@@ -7153,6 +8003,6 @@
       ENDIF
     END FUNCTION svf_lt
-    
- 
+
+
 !-- quicksort.f -*-f90-*-
 !-- Author: t-nissie, adaptation J.Resler
@@ -7186,5 +8036,4 @@
     END SUBROUTINE quicksort_svf
 
-    
     PURE FUNCTION csf_lt(csf1,csf2) result (res)
       TYPE (t_csf), INTENT(in) :: csf1,csf2
@@ -7241,5 +8090,5 @@
         INTEGER(iwp)                            :: iread, iwrite
         TYPE(t_csf), DIMENSION(:), POINTER      :: acsfnew
-!        CHARACTER(100)                          :: msg
+        CHARACTER(100)                          :: msg
 
         IF ( newsize == -1 )  THEN
@@ -7270,10 +8119,5 @@
                          .AND.  acsfnew(iwrite)%itz == acsf(iread)%itz &
                          .AND.  acsfnew(iwrite)%isurfs == acsf(iread)%isurfs )  THEN
-!--                 We could simply take either first or second rtransp, both are valid. As a very simple heuristic about which ray
-!--                 probably passes nearer the center of the target box, we choose DIF from the entry with greater CSF, since that
-!--                 might mean that the traced beam passes longer through the canopy box.
-                    IF ( acsfnew(iwrite)%rsvf < acsf(iread)%rsvf )  THEN
-                        acsfnew(iwrite)%rtransp = acsf(iread)%rtransp
-                    ENDIF
+
                     acsfnew(iwrite)%rsvf = acsfnew(iwrite)%rsvf + acsf(iread)%rsvf
 !--                 advance reading index, keep writing index
@@ -7310,6 +8154,6 @@
         ncsfla = newsize
 
-!         WRITE(msg,'(A,2I12)') 'Grow acsf2:',ncsfl,ncsfla
-!         CALL radiation_write_debug_log( msg )
+        WRITE(msg,'(A,2I12)') 'Grow acsf2:',ncsfl,ncsfla
+        CALL radiation_write_debug_log( msg )
 
     END SUBROUTINE merge_and_grow_csf
@@ -7443,30 +8287,25 @@
                SELECT CASE ( d )
 
-               CASE (iup_u,iup_l,iup_a)                    !- gridbox up_facing face
+               CASE (iup_u,iup_l)                          !- gridbox up_facing face
                   sw_gridbox(1) = surfinsw(l)
                   lw_gridbox(1) = surfinlw(l)
                   swd_gridbox(1) = surfinswdif(l)
 
-               CASE (idown_a)                         !- gridbox down_facing face
-                  sw_gridbox(2) = surfinsw(l)
-                  lw_gridbox(2) = surfinlw(l)
-                  swd_gridbox(2) = surfinswdif(l)
-
-               CASE (inorth_u,inorth_l,inorth_a)  !- gridbox north_facing face
+               CASE (inorth_u,inorth_l)                    !- gridbox north_facing face
                   sw_gridbox(3) = surfinsw(l)
                   lw_gridbox(3) = surfinlw(l)
                   swd_gridbox(3) = surfinswdif(l)
 
-               CASE (isouth_u,isouth_l,isouth_a)  !- gridbox south_facing face
+               CASE (isouth_u,isouth_l)                    !- gridbox south_facing face
                   sw_gridbox(4) = surfinsw(l)
                   lw_gridbox(4) = surfinlw(l)
                   swd_gridbox(4) = surfinswdif(l)
 
-               CASE (ieast_u,ieast_l,ieast_a)      !- gridbox east_facing face
+               CASE (ieast_u,ieast_l)                      !- gridbox east_facing face
                   sw_gridbox(5) = surfinsw(l)
                   lw_gridbox(5) = surfinlw(l)
                   swd_gridbox(5) = surfinswdif(l)
 
-               CASE (iwest_u,iwest_l,iwest_a)      !- gridbox west_facing face
+               CASE (iwest_u,iwest_l)                      !- gridbox west_facing face
                   sw_gridbox(6) = surfinsw(l)
                   lw_gridbox(6) = surfinlw(l)
@@ -7520,5 +8359,5 @@
     INTEGER(iwp) ::  j !< 
     INTEGER(iwp) ::  k !< 
-    INTEGER(iwp) ::  m !< index of current surface element 
+    INTEGER(iwp) ::  l, m !< index of current surface element
 
     IF ( mode == 'allocate' )  THEN
@@ -7604,4 +8443,22 @@
                 rad_sw_hr_av = 0.0_wp
 
+             CASE ( 'rad_mrt_sw' )
+                IF ( .NOT. ALLOCATED( mrtinsw_av ) )  THEN
+                   ALLOCATE( mrtinsw_av(nmrtbl) )
+                ENDIF
+                mrtinsw_av = 0.0_wp
+
+             CASE ( 'rad_mrt_lw' )
+                IF ( .NOT. ALLOCATED( mrtinlw_av ) )  THEN
+                   ALLOCATE( mrtinlw_av(nmrtbl) )
+                ENDIF
+                mrtinlw_av = 0.0_wp
+
+             CASE ( 'rad_mrt' )
+                IF ( .NOT. ALLOCATED( mrt_av ) )  THEN
+                   ALLOCATE( mrt_av(nmrtbl) )
+                ENDIF
+                mrt_av = 0.0_wp
+
           CASE DEFAULT
              CONTINUE
@@ -7819,4 +8676,19 @@
              ENDIF
 
+          CASE ( 'rad_mrt_sw' )
+             IF ( ALLOCATED( mrtinsw_av ) )  THEN
+                mrtinsw_av(:) = mrtinsw_av(:) + mrtinsw(:)
+             ENDIF
+
+          CASE ( 'rad_mrt_lw' )
+             IF ( ALLOCATED( mrtinlw_av ) )  THEN
+                mrtinlw_av(:) = mrtinlw_av(:) + mrtinlw(:)
+             ENDIF
+
+          CASE ( 'rad_mrt' )
+             IF ( ALLOCATED( mrt_av ) )  THEN
+                mrt_av(:) = mrt_av(:) + mrt(:)
+             ENDIF
+
           CASE DEFAULT
              CONTINUE
@@ -7828,5 +8700,5 @@
        SELECT CASE ( TRIM( variable ) )
 
-         CASE ( 'rad_net*' )
+          CASE ( 'rad_net*' )
              IF ( ALLOCATED( rad_net_av ) ) THEN
                 DO  i = nxlg, nxrg
@@ -7974,4 +8846,19 @@
              ENDIF
 
+          CASE ( 'rad_mrt_sw' )
+             IF ( ALLOCATED( mrtinsw_av ) )  THEN
+                mrtinsw_av(:) = mrtinsw_av(:)  / REAL( average_count_3d, KIND=wp )
+             ENDIF
+
+          CASE ( 'rad_mrt_lw' )
+             IF ( ALLOCATED( mrtinlw_av ) )  THEN
+                mrtinlw_av(:) = mrtinlw_av(:) / REAL( average_count_3d, KIND=wp )
+             ENDIF
+
+          CASE ( 'rad_mrt' )
+             IF ( ALLOCATED( mrt_av ) )  THEN
+                mrt_av(:) = mrt_av(:) / REAL( average_count_3d, KIND=wp )
+             ENDIF
+
        END SELECT
 
@@ -8009,5 +8896,6 @@
               'rad_sw_hr_xy', 'rad_lw_cs_hr_xz', 'rad_lw_hr_xz',               &
               'rad_sw_cs_hr_xz', 'rad_sw_hr_xz', 'rad_lw_cs_hr_yz',            &
-              'rad_lw_hr_yz', 'rad_sw_cs_hr_yz', 'rad_sw_hr_yz' )
+              'rad_lw_hr_yz', 'rad_sw_cs_hr_yz', 'rad_sw_hr_yz',               &
+              'rad_mrt', 'rad_mrt_sw', 'rad_mrt_lw' )
           grid_x = 'x'
           grid_y = 'y'
@@ -8037,5 +8925,5 @@
 ! Description:
 ! ------------
-!> Subroutine defining 3D output variables
+!> Subroutine defining 2D output variables
 !------------------------------------------------------------------------------!
  SUBROUTINE radiation_data_output_2d( av, variable, found, grid, mode,         &
@@ -8456,17 +9344,14 @@
     CHARACTER (LEN=*) ::  variable !< 
 
-    INTEGER(iwp) ::  av    !< 
-    INTEGER(iwp) ::  i     !< 
-    INTEGER(iwp) ::  j     !< 
-    INTEGER(iwp) ::  k     !< 
-    INTEGER(iwp) ::  nzb_do   !< 
-    INTEGER(iwp) ::  nzt_do   !< 
-
-    LOGICAL      ::  found !< 
-
-    REAL(wp) ::  fill_value = -999.0_wp    !< value for the _FillValue attribute
-
-    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf !< 
-
+    INTEGER(iwp) ::  av          !<
+    INTEGER(iwp) ::  i, j, k, l  !<
+    INTEGER(iwp) ::  nzb_do      !<
+    INTEGER(iwp) ::  nzt_do      !<
+
+    LOGICAL      ::  found       !<
+
+    REAL(wp)     ::  fill_value = -999.0_wp    !< value for the _FillValue attribute
+
+    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf !<
 
     found = .TRUE.
@@ -8657,4 +9542,64 @@
                ENDDO
             ENDDO
+         ENDIF
+
+      CASE ( 'rad_mrt_sw' )
+         local_pf = REAL( fill_value, KIND = wp )
+         IF ( av == 0 )  THEN
+            DO  l = 1, nmrtbl
+               i = mrtbl(ix,l)
+               j = mrtbl(iy,l)
+               k = mrtbl(iz,l)
+               local_pf(i,j,k) = mrtinsw(l)
+            ENDDO
+         ELSE
+            IF ( ALLOCATED( mrtinsw_av ) ) THEN
+               DO  l = 1, nmrtbl
+                  i = mrtbl(ix,l)
+                  j = mrtbl(iy,l)
+                  k = mrtbl(iz,l)
+                  local_pf(i,j,k) = mrtinsw_av(l)
+               ENDDO
+            ENDIF
+         ENDIF
+
+      CASE ( 'rad_mrt_lw' )
+         local_pf = REAL( fill_value, KIND = wp )
+         IF ( av == 0 )  THEN
+            DO  l = 1, nmrtbl
+               i = mrtbl(ix,l)
+               j = mrtbl(iy,l)
+               k = mrtbl(iz,l)
+               local_pf(i,j,k) = mrtinlw(l)
+            ENDDO
+         ELSE
+            IF ( ALLOCATED( mrtinlw_av ) ) THEN
+               DO  l = 1, nmrtbl
+                  i = mrtbl(ix,l)
+                  j = mrtbl(iy,l)
+                  k = mrtbl(iz,l)
+                  local_pf(i,j,k) = mrtinlw_av(l)
+               ENDDO
+            ENDIF
+         ENDIF
+
+      CASE ( 'rad_mrt' )
+         local_pf = REAL( fill_value, KIND = wp )
+         IF ( av == 0 )  THEN
+            DO  l = 1, nmrtbl
+               i = mrtbl(ix,l)
+               j = mrtbl(iy,l)
+               k = mrtbl(iz,l)
+               local_pf(i,j,k) = mrt(l)
+            ENDDO
+         ELSE
+            IF ( ALLOCATED( mrt_av ) ) THEN
+               DO  l = 1, nmrtbl
+                  i = mrtbl(ix,l)
+                  j = mrtbl(iy,l)
+                  k = mrtbl(iz,l)
+                  local_pf(i,j,k) = mrt_av(l)
+               ENDDO
+            ENDIF
          ENDIF
 
@@ -9342,16 +10287,16 @@
 !> Subroutine writes debug information
 !------------------------------------------------------------------------------!
-! SUBROUTINE radiation_write_debug_log ( message )
+ SUBROUTINE radiation_write_debug_log ( message )
     !> it writes debug log with time stamp
-!    CHARACTER(*)  :: message
-!    CHARACTER(15) :: dtc
-!    CHARACTER(8)  :: date
-!    CHARACTER(10) :: time
-!    CHARACTER(5)  :: zone
-!    CALL date_and_time(date, time, zone)
-!    dtc = date(7:8)//','//time(1:2)//':'//time(3:4)//':'//time(5:10)
-!    WRITE(9,'(2A)') dtc, TRIM(message)
-!    FLUSH(9)
-! END SUBROUTINE radiation_write_debug_log
+    CHARACTER(*)  :: message
+    CHARACTER(15) :: dtc
+    CHARACTER(8)  :: date
+    CHARACTER(10) :: time
+    CHARACTER(5)  :: zone
+    CALL date_and_time(date, time, zone)
+    dtc = date(7:8)//','//time(1:2)//':'//time(3:4)//':'//time(5:10)
+    WRITE(9,'(2A)') dtc, TRIM(message)
+    FLUSH(9)
+ END SUBROUTINE radiation_write_debug_log
 
  END MODULE radiation_model_mod
Index: palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 3322)
+++ palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 3337)
@@ -25,4 +25,10 @@
 ! -----------------
 ! $Id$
+! (from branch resler)
+! Add biometeorology,
+! fix chemistry output call,
+! move usm calls
+! 
+! 3294 2018-10-01 02:37:10Z raasch
 ! changes concerning modularization of ocean option
 ! 
@@ -260,4 +266,7 @@
     USE radiation_model_mod,                                                   &
         ONLY:  radiation, radiation_3d_data_averaging
+
+    USE biometeorology_mod,                                                    &
+        ONLY:  biometeorology_3d_data_averaging
 
     USE surface_mod,                                                           &
@@ -305,12 +314,7 @@
 
        DO  ii = 1, doav_n
-!
-!--       Temporary solution to account for data output within the new urban 
-!--       surface model (urban_surface_mod.f90), see also SELECT CASE ( trimvar )
+
           trimvar = TRIM( doav(ii) )
-          IF ( urban_surface  .AND.  trimvar(1:4) == 'usm_' )  THEN
-             trimvar = 'usm_output'
-          ENDIF
-       
+
           SELECT CASE ( trimvar )
 
@@ -495,9 +499,4 @@
                 z0q_av = 0.0_wp
 
-             CASE ( 'usm_output' )
-!             
-!--             Block of urban surface model outputs
-                CALL usm_average_3d_data( 'allocate', doav(ii) )
-              
 
              CASE DEFAULT
@@ -505,10 +504,16 @@
 !
 !--             Allocating and initializing data arrays for other modules
+
+                IF ( air_chemistry  .AND. &
+                     (trimvar(1:3) == 'kc_' .OR. trimvar(1:3) == 'em_') )  THEN
+                   CALL chem_3d_data_averaging( 'allocate', doav(ii) )
+                ENDIF
+
                 IF ( bulk_cloud_model )  THEN
                    CALL bcm_3d_data_averaging( 'allocate', doav(ii) )
                 ENDIF
 
-                IF ( air_chemistry  .AND.  trimvar(1:3) == 'kc_')  THEN
-                   CALL chem_3d_data_averaging( 'allocate', doav(ii) )
+                IF ( radiation  .AND.  trimvar(1:4) == 'bio_' )  THEN
+                   CALL biometeorology_3d_data_averaging( 'allocate', doav(ii) )
                 ENDIF
 
@@ -529,10 +534,14 @@
                 ENDIF
 
+                CALL tcm_3d_data_averaging( 'allocate', doav(ii) )
+
+                IF ( urban_surface  .AND.  trimvar(1:4) == 'usm_' )  THEN
+                   CALL usm_average_3d_data( 'allocate', doav(ii) )
+                ENDIF
+
                 IF ( uv_exposure  .AND.  trimvar(1:5) == 'uvem_')  THEN
                    CALL uvem_3d_data_averaging( 'allocate', doav(ii) )
                 ENDIF
 
-                CALL tcm_3d_data_averaging( 'allocate', doav(ii) )
-
 !
 !--             User-defined quantities
@@ -548,11 +557,6 @@
 !-- Loop of all variables to be averaged.
     DO  ii = 1, doav_n
-!
-!--       Temporary solution to account for data output within the new urban 
-!--       surface model (urban_surface_mod.f90), see also SELECT CASE ( trimvar )
-          trimvar = TRIM( doav(ii) )
-          IF ( urban_surface  .AND.  trimvar(1:4) == 'usm_' )  THEN
-             trimvar = 'usm_output'
-          ENDIF
+
+       trimvar = TRIM( doav(ii) )
 !
 !--    Store the array chosen on the temporary array.
@@ -1146,41 +1150,45 @@
              ENDIF
 
-          CASE ( 'usm_output' )
-!             
-!--          Block of urban surface model outputs.
+          CASE DEFAULT
+!
+!--          Summing up data from other modules
+             IF ( bulk_cloud_model )  THEN
+                CALL bcm_3d_data_averaging( 'sum', doav(ii) )
+             ENDIF
+
+             IF ( air_chemistry  .AND. &
+                  (trimvar(1:3) == 'kc_' .OR. trimvar(1:3) == 'em_') )  THEN
+                CALL chem_3d_data_averaging( 'sum',doav(ii) )
+             ENDIF
+
+             IF ( radiation   .AND.  trimvar(1:4) == 'bio_')  THEN
+                CALL biometeorology_3d_data_averaging( 'sum', doav(ii) )
+             ENDIF
+
+             IF ( gust_module_enabled )  THEN
+                CALL gust_3d_data_averaging( 'sum', doav(ii) )
+             ENDIF
+
+             IF ( land_surface )  THEN
+                CALL lsm_3d_data_averaging( 'sum', doav(ii) )
+             ENDIF
+
+             IF ( ocean_mode )  THEN
+                CALL ocean_3d_data_averaging( 'sum', doav(ii) )
+             ENDIF
+
+             IF ( radiation )  THEN
+                CALL radiation_3d_data_averaging( 'sum', doav(ii) )
+             ENDIF
+
+             CALL tcm_3d_data_averaging( 'sum', doav(ii) )
+
 !--          In case of urban surface variables it should be always checked
 !--          if respective arrays are allocated, at least in case of a restart
 !--          run, as averaged usm arrays are not read from file at the moment.
-             CALL usm_average_3d_data( 'allocate', doav(ii) )
-             CALL usm_average_3d_data( 'sum', doav(ii) )
-
-          CASE DEFAULT
-!
-!--          Summing up data from other modules
-             IF ( bulk_cloud_model )  THEN
-                CALL bcm_3d_data_averaging( 'sum', doav(ii) )
-             ENDIF
-
-             IF ( air_chemistry  .AND.  trimvar(1:3) == 'kc_')  THEN
-                CALL chem_3d_data_averaging( 'sum',doav(ii) )
-             ENDIF
-
-             IF ( gust_module_enabled )  THEN
-                CALL gust_3d_data_averaging( 'sum', doav(ii) )
-             ENDIF
-
-             IF ( land_surface )  THEN
-                CALL lsm_3d_data_averaging( 'sum', doav(ii) )
-             ENDIF
-
-             IF ( ocean_mode )  THEN
-                CALL ocean_3d_data_averaging( 'sum', doav(ii) )
-             ENDIF
-
-             IF ( radiation )  THEN
-                CALL radiation_3d_data_averaging( 'sum', doav(ii) )
-             ENDIF
-
-             CALL tcm_3d_data_averaging( 'sum', doav(ii) )
+             IF ( urban_surface  .AND.  trimvar(1:4) == 'usm_' )  THEN
+                CALL usm_average_3d_data( 'allocate', doav(ii) )
+                CALL usm_average_3d_data( 'sum', doav(ii) )
+             ENDIF
 
              IF ( uv_exposure )  THEN
Index: palm/trunk/SOURCE/time_integration_spinup.f90
===================================================================
--- palm/trunk/SOURCE/time_integration_spinup.f90	(revision 3322)
+++ palm/trunk/SOURCE/time_integration_spinup.f90	(revision 3337)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! (from branch resler)
+! Add pt1 initialization
+! 
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -295,4 +299,7 @@
                 k   = surf_usm_h%k(m)
                 pt(k,j,i) = pt_spinup
+                !!!!!!!!!!!!!!!!HACK!!!!!!!!!!!!!
+                surf_usm_h%pt1 = pt_spinup
+                !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
              ENDDO
 
@@ -303,4 +310,7 @@
                    k   = surf_usm_v(l)%k(m)
                    pt(k,j,i) = pt_spinup
+                   !!!!!!!!!!!!!!!!HACK!!!!!!!!!!!!!
+                   surf_usm_v(l)%pt1 = pt_spinup
+                   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                 ENDDO
              ENDDO
